//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#pragma once
#include "Basis.h"
#include "Segment.h"

class Tile																	//	a class for the tiles on the torus
	{
	public:
	bool isSelected;														//	whether the point is currently selected
	bool hasPoint;															//	whether there is a point on this tile
	Vector position;														//	position in 3-space relative to viewer
	Vector normal;															//	normal vector for this tile
	short intensity;														//	intensity of colour for this tile
	BPoint *topLeft, *topRight, *bottomLeft, *bottomRight;					//	pointers to the 4 corners
	SegmentNode *segmentList;												//	list of all the line segments on this tile
	
	Tile();																	//	constructor
	~Tile();																//	destructor
	
	bool Contains(BPoint P);												//	tests whether a point is inside the tile
	void PrintToStream();													//	dump contents to output stream

	void AddSegment(Segment *newSegment);									//	adds a segment to the segment list
	void RemoveSegment(Segment *oldSegment);								//	removes a segment from the segment list
	}; // end of Tile class
	
typedef Tile *TilePointer;													//	to make sorting easier

int compareTiles(const void *e1, const void *e2);							//	routine for comparing tiles
