//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#pragma once

class TorusView;															//	forward declaration

#include "TorusBlitView.h"
#include "TorusToolView.h"

#define B_KYBD_2 0x59
#define B_KYBD_4 0x48
#define B_KYBD_5 0x49
#define B_KYBD_6 0x4A
#define B_KYBD_7 0x37
#define B_KYBD_8 0x38
#define B_KYBD_9 0x39

class TorusView : public BView												//	a view for displaying a torus
	{
	private:
	BBitmap *theBlitMap;													//	bitmap from which to blit
	TorusBlitView *theBlitView;												//	view to use to set up blitting
	Vector theViewPoint;													//	the viewpoint
	Vector theViewPlane;													//	the viewplane
	Vector yMult, zMult;													//	precalculated vectors for scaling
	BPoint theScreenCentre;													//	the centre of the window
	Vector theViewNormal;													//	normalized version of foregoing 
	Torus *theTorus;														//	the torus object

	public:	
	TorusToolView *theTorusToolView;										//	the torus tool view

	TorusView(BRect theFrame, Torus *newTorus);								//	constructor
	~TorusView();															//	destructor

	virtual void MessageReceived(BMessage *theEvent);						//	processes messages
	virtual void Draw(BRect updateRect);									//	draw the torus
	virtual void MouseDown(BPoint where);									//	handle a mouse click
	virtual void KeyDown(const char *bytes, int32 numBytes);				//	handle a keystroke
	}; // end of TorusView class
